# @(#)DN2.tcl	1.4
# Modularizing this so that it is callable and so I can have multiple DN2 windows up
# Going to take some careful checking of globals and such

namespace eval DN2 {

    proc setup {windowname} {
	# script for creating the initial canvas with 
	# a draw button and a data selection button
	wm withdraw .
	catch {destroy $windowname}
	set w [toplevel $windowname]
	wm title $w "TreeWin"

	# create the tree display canvas
	# Construct the frame call treeview which will contain the canvas
	# and a horizontal and vertical scrollbar.

	set tview [frame $w.treeview]

	scrollbar $tview.hscroll -orient horiz -command "$tview.canv xview"
	scrollbar $tview.vscroll -command "$tview.canv yview"
	set canvas [canvas $tview.canv -relief sunken -borderwidth 2 -scrollregion {0i 0i 6i 6i} \
		-width 3i -height 3i \
		-xscrollcommand "$tview.hscroll set" \
		-yscrollcommand "$tview.vscroll set"]

	# create tree in the canvas: this will now be taken care of in the TreeData code
	set tree [tree $tview.canv.t -layout horizontal]

	# initialize the treedata
	TreeData::init $canvas
	TreeData::setdisplaytreeid $canvas $tree

	# put the frame components into a grid
	grid $tview.canv -padx 1 -pady 1 -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid $tview.hscroll -padx 1 -pady 1 -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
	grid $tview.vscroll -padx 1 -pady 1 -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
	grid rowconfig $tview 0 -weight 1 -minsize 0
	grid columnconfig $tview 0 -weight 1 -minsize 0
	pack  $tview -side top -fill both -expand yes
	
	puts "Creating menu now."
	menu $w.menu -tearoff 0

	set m [menu $w.menu.file -tearoff 0]
	$w.menu add cascade -label "File" -menu $m -underline 0
	$m add command -label "New" -command "DN2Application::NewTree $canvas"
	$m add command -label "Open" -command "DN2Application::LoadDN2 $canvas"
	$m add command -label "Save" -command "DN2Application::SaveDN2 $canvas"
	$m add command -label "Save As" -command "DN2Application::SaveDN2 $canvas"
	$m add separator
	$m add command -label "Dismiss" -command "DN2Application::DestroyApp $w $canvas"
	set m [menu $w.menu.nodes -tearoff 0]
	$w.menu add cascade -label "Nodes" -menu $m -underline 0
	$m add command -label "Add Node" -command "AddSubNode::CreateAddSubNodeWin $canvas"
	$m add command -label "Add TEXT Node" -command "AddSubNode::AddTextSubNodeTo $canvas selected"
	$m add command -label "Edit Attributes" -command "ViewAttribs::CreateViewAttribWin $canvas"
	$m add command -label "Prune Node" -command "PruneNode $canvas $tree selected"
	$m add command -label "Remove Node" -command "RemoveNode $canvas $tree selected"
	set m [menu $w.menu.view -tearoff 0]
	$w.menu add cascade -label "View" -menu $m -underline 0
	$m add command -label "DN2" -command "DN2Win::CreateDN2Win $canvas $tree"
	
	$w configure -menu $w.menu

	setup_bindings $canvas $tree
 
	DN2Application::NewTree $canvas
    }
}



