# @(#)DN2Appl.tcl	1.7

# Putting the routines which deal with the main DN2 screen in the
# DN2Application namespace
#

namespace eval DN2Application {

proc CreateTree {canvas treedata} {
    # creates a tree from tclform dn2 data
    PopulateTreeWithDN2 $canvas $treedata
    MakeViewableTree $canvas
}

proc NewTree {canvas} {
    # clear out old tree
    # start new one with a single DN2 node
    TreeData::makenewroot $canvas DN2 {{}} {} 
    set tree [TreeData::getdisplaytreeid $canvas]
    $tree prune {}
    #AddNode $canvas $tree {} {DN2 {{ID }} {}}
    MakeViewableTree $canvas
    UpdateWindows $canvas
    set tmp $canvas
    while {[winfo parent $tmp] != "."} {
	set tmp [winfo parent $tmp]
    }
    wm title $tmp New
}

proc ClearTree {canvas} {
    TreeData::prune_node [TreeData::getrootid $canvas]
    set tree [TreeData::getdisplaytreeid $canvas]
    $tree prune {}
    set tmp $canvas
    while {[winfo parent $tmp] != "."} {
	set tmp [winfo parent $tmp]
    }
    wm title $tmp " "
}

proc UpdateWindows {canvas} {

    AddSubNode::UpdateWindow $canvas
    ViewAttribs::UpdateWindow $canvas
    # DN2Win::UpdateWindow $canvas
}

proc DestroyApp {window canvas} {
    AddSubNode::DestroyWin $canvas
    ViewAttribs::DestroyWin $canvas
    AddAttrib::DestroyWin $canvas
    DN2Win::DestroyWin $canvas
    destroy $window
}

proc LoadDN2 {canvas} {
    # pull up filepicker
    # search for files ending in dn2
    # read in the file
    # parse it into tclform
    # do a draw tree on it.
    set filename [tk_getOpenFile -defaultextension "dn2" -title "Open DN2"]
    if {[string length $filename] > 0} {
	set infile [open $filename "r"]
	set newdn2 [read $infile]
	close $infile
	set dn2error [parsedn2 -tcl $newdn2 tcldn2]
	if {$dn2error != 0} {
	    #error
	} else {
	    ClearTree $canvas
	    CreateTree $canvas [lindex $tcldn2 0]
	    UpdateWindows $canvas 
	    set tmp $canvas
	    while {[winfo parent $tmp] != "."} {
		set tmp [winfo parent $tmp]
	    }
	    wm title $tmp [file tail $filename]
	}
    }
}

proc SaveDN2 {canvas} {
    # get dn2 string
    # parse it if error see if user wishes to continue
    # if so pull up savefilepicker
    # have user enter name
    # open saving file
    # write string to it
    # close
    DN2Construct::GetDN2String $canvas dn2string
    set dn2error [parsedn2 $dn2string]
    if {$dn2error != 0} {
	set answer [tk_messageBox -type yesno -message "Parse error in your DN2.\nDo you still wish to save?"]
	if {$answer == "no"} {
	    puts "Not Saving"
	    return
	}
    }
    set filename [tk_getSaveFile -initialfile "test.dn2" -title "Save DN2"]
    if {[string length $filename] > 0} {
	set outfile [open $filename "w"]
	puts $outfile $dn2string
	close $outfile
	set tmp $canvas
	while {[winfo parent $tmp] != "."} {
	    set tmp [winfo parent $tmp]
	}
	wm title $tmp [file tail $filename]
    } else {
	puts "No filename entered."
    }
}

}
