# @(#)DN2Construct.tcl	1.4
# The methods for construction of the DN2 representation of the tree.
# Basically fills a variable with the DN2 string rep of the tree.


namespace eval DN2Construct {

proc ConstructDN2Starttag {canvas textvar nodeid} {
    upvar 1 $textvar textstring
    global nodetypes_with_value
    #set tags [$canvas gettags $node]
    set nodetype [TreeData::getnodetype $nodeid]
    set attribs [TreeData::getattriblist $nodeid]
    set textdata [TreeData::gettextdata $nodeid]
    #set attribs [lindex $tags 1]

    #puts "entered construct starttag"
    #puts " with tags = $tags"
    #puts " with nodetype = $nodetype"
    #puts " [string compare $nodetype qtd-text]"
    
    set outvar [string toupper "<$nodetype"]

    for {set i 0} {$i < [llength $attribs]} {incr i} {
	if {[llength [lindex $attribs $i]] != 0} {
	    set attr_name [string toupper [lindex [lindex $attribs $i] 0]]
	    set attr_value [lindex [lindex $attribs $i] 1]
	    append outvar " $attr_name=$attr_value "
	}
    }
    append outvar ">\n"
    append textstring $outvar

    if {[lsearch -exact $nodetypes_with_value [string toupper $nodetype]] != -1} {
	set textlength [llength $textdata]
	for {set i 1} {$i < $textlength} {incr i 3} {
	    append textstring [lindex $textdata $i]
	}
    }
    
}

proc ConstructDN2Endtag {canvas textvar nodeid} {
    upvar 1 $textvar textstring
    set nodetype [TreeData::getnodetype $nodeid]
    append textstring [string toupper "</$nodetype>\n"]
}

#proc PutQuotedText {textvar id} {
#global qtd_text_value
#    upvar 1 $textvar textstring
#    set textlength [llength $qtd_text_value($id)]
#    for {set i 1} {$i < $textlength} {incr i 3} {
#	append textstring [lindex $qtd_text_value($id) $i]
#    }
#}


proc RecursePopulateDN2Str {canvas textvar nodeid} {
    global DN2_header
    upvar 1 $textvar textstring
    if {$nodeid == [TreeData::getrootid $canvas]} {
	# for the root node insert the DN2 header
	append textstring $DN2_header
    }
    ConstructDN2Starttag $canvas textstring $nodeid
    for {set child [TreeData::getchildid $nodeid]} {$child != 0} {set child [TreeData::getsiblingid $child]} {
	RecursePopulateDN2Str $canvas textstring $child
    }
    ConstructDN2Endtag $canvas textstring $nodeid
}


proc GetDN2String {canvas textvar} {
    upvar 1 $textvar textstring
    RecursePopulateDN2Str $canvas textstring [TreeData::getrootid $canvas]
}

}
