# %W%

# These outline in red the nodebox upon entering it and re-outline it in black upon leaving
# this currently works by highlighting the node when the text is hit.
# This problem has been solved.  A rectangle is empty unless -fill is used.

proc setup_bindings {canvas tree} {
    $canvas bind node <Enter> "outline_nodebox $canvas current red"
    $canvas bind node <Leave> "outline_nodebox $canvas current black"
    $canvas bind node <Button-1> "select_nodebox $canvas $tree current"
    # this conflicts with the move node stuff see about making button-1 do double duty
    # $canvas bind selected <Button-3> "unselect_nodebox $canvas $tree current"

    setup_move_bindings $canvas
}


# Given the id or tag of the nodetext and a color this
# will determine the nodebox and then change the outline to $color
proc outline_nodebox {canvas id color} {
    set tag [lindex [$canvas gettags $id] 1]:box
    $canvas itemconfigure $tag -outline $color
}


# Given the id or tag of the node this will determine the
# node box and then changes the text to yellow
# Deletes the selected tag prior to placing it on the node
# therefore only one node may selected.
# This routine checks to see if there exists a node with 
# the viewing tag.  If so then it calls CreateAttribViewWin.
proc select_nodebox {canvas tree id} {
    set tag [lindex [$canvas gettags $id] 1]:txt
    unselect_nodebox $canvas $tree selected
    $canvas addtag selected withtag $tag
    $canvas itemconfigure $tag -fill yellow

    # Calling main routine which updates the windows
    DN2Application::UpdateWindows $canvas

}

# Given the node id this will remove the selected tag and 
# change the text back to black
proc unselect_nodebox {canvas tree id} {
    set tag [lindex [$canvas gettags $id] 1]:txt
    $canvas dtag selected
    $canvas itemconfigure $tag -fill black
    DN2Application::UpdateWindows $canvas
}

# loops through all nodes with the selected tag and unselects them
# no longer needed...
proc unselect_all {canvas} {
    foreach i [$canvas find withtag selected] {
	unselect_nodebox [lindex [$canvas gettags $i] 1]:txt
    }
}

